
c   R/R_zams evaluation (hotter stars)

c   An example data (HD122980), vis. mag=4.343, parallax 7.31
c			 (B-V)_0 = -0.2, T_eff=20000 K
c			 Bol. Correction = 2.0 

	dimension temp(4),bv0(4),bc0(4),ams(4),ggray0(4),rs(4)
	data temp/4.54,4.398,4.204,4.079/
	data bv0/-0.30, -0.25, -0.16, -0.10/
	data bc0/3.0, 2.2, 1.0, 0.6/
	data ams/13.2, 8.7, 4.57, 2.88/
	data ggray0/4.0, 4.1, 4.22, 4.25/
	data rs/7.4, 6.64, 4.33, 2.74/

	write(*,*) ' vis. mag., parallax, eff. temp. ? (B-V)_0 ? '
	read(*,*)amv,p,t,bvstar

        call aintep(bvstar,ams0,bv0,ams,4,4,iee)
	call aintep(bvstar,tt0,bv0,temp,4,4,iex)
	call aintep(bvstar,rs0,bv0,rs,4,4,iey)
	call aintep(log10(t),gr,temp,ggray0,4,4,ig)

	write(*,*) ' Gray (1992) scale '
	write(*,*)'M_sol',ams0
	write(*,*)'T_eff',10.**(tt0)
	write(*,*)'Radii',rs0
	write(*,*)'log g',gr
c Evolutionary track data
	write(*,*) ' Evolutionary track data '
	write(*,*) ' logg 4.29 (5M_sol) = 1, 4.26 (>5M_sol) =2, and BC ?'
	read(*,*)isw,bcx

c	call aintep(log10(t),bcx,temp,bc0,4,4,ie)
	bc=bcx
c	write(*,*) ' BC Gray scale',bcx
	call aintep(log10(t),bvx,temp,bv0,4,4,ie)
	write(*,*)' B-V Gray scale', bvx

	tsun=5770.0
c	d=1./p
	p=p*0.001
	tt=t/tsun
	gt=4.29
	if(isw.eq.2) gt=4.26

	am=amv+5.0*log10(p)+5.0-bc
c	write(*,*)bc,am
	r1=-0.2*am+0.944-2.*log10(tt)
c R_zams
	rr=r1+0.5*(gt-4.438)
	r=10.**(r1)
	rr=10.**(rr)
c He evolutionary status; Glagolevskij (1994)
	rgla=8.46-0.2*am-2.*log10(t)
c in R_solar
	write(*,*)' Radii: Abs. magn.', r,' Glagol. scale',10**(rgla)
	write(*,*) ' R_zams'
	write(*,*)rr
	write(*,*) ' R in R_zams'
	write(*,*)r/rr

	gmy=(r)**2.0
	amas=log10(ams0)
	gmy=4.438-2.0*log10(r)+amas
	ggl=4.438-2.0*rgla+amas
	write(*,*) ' log g (Abs. magn. scale, Glagol. scale',gmy,ggl

        call ggray(bvstar,g)
        write(*,*)'Gray (colour index) scale',g
c	rrr=sqrt(gt/gmy)
c	write(*,*)'R/R_zams from surface gravity',rrr

	stop 7
	end

	subroutine ggray(bvs,tef)
c
c surface gravity (Gray 1998)
c
        a0=4.25
        a1=-0.3124
        a2=-0.5022
        a3=6.5320
        a4=-9.9431
        a5=5.7581
        a6=-1.1706

c1       write(*,*) '  B-V ? [0=end]'
c        read(*,'(f10.0,f8.3)')bv
	 bv=bvs
        tef=a0+a1*bv+a2*bv**2.+a3*bv**3.+a4*bv**4.+a5*bv**5.+
     *      a6*bv**6.
	return
        end


	SUBROUTINE AINTEP(XP,P,X1,F1,NDIM,N,IER)
c       SUBROUTINE A I N T E P  : SPLINE INTERPOLATION SCHEME BASED
c                                ON HERMITE POLYNOMIALS
c        INPUT : XP  - THE CHOSEN ARGUMENT VALUE
c                X   - THE VECTOR OF INDEPENDENT VALUES
c                F   - THE VECTOR OF FUNCTION OR DEPENDENT VALUES
c                N   - THE NUMBER OF POINTS IN THE (X,F) VECTORS
c       OUTPUT : P   - THE RESULTANT INTERPOLATED VALUE
c                IER - THE RESULTANT ERROR PARAMETER
c
c        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        REAL LP1,LP2,L1,L2
        DIMENSION F1(NDIM),X1(NDIM)

        IER=1
        IO=1
        IUP=0
        IF(X1(2).LT.X1(1)) IUP=1
        N1=N-1
        IF((XP.GE.X1(N).AND.IUP.EQ.0).OR.(XP.LE.X1(N).AND.IUP.EQ.1))THEN
         P=F1(N)
         IER=2
         RETURN
        ELSE IF((XP.LE.X1(1).AND.IUP.EQ.0).OR.
     *   (XP.GE.X1(1).AND.IUP.EQ.1)) THEN
         P=F1(1)
         IER=2
         RETURN
        END IF
        DO 1 I=IO,N
         IF(XP.LT.X1(I).AND.IUP.EQ.0) GOTO 2
         IF(XP.GT.X1(I).AND.IUP.EQ.1) GOTO 2
1       CONTINUE
        P=F1(N)
        IER=2
        RETURN
2       I=I-1
        IF(I.EQ.IO-1) GOTO 4
        IO=I+1
        LP1=1./(X1(I)-X1(I+1))
        LP2=1./(X1(I+1)-X1(I))
        IF(I.EQ.1) FP1=(F1(2)-F1(1))/(X1(2)-X1(1))
        IF(I.EQ.1) GOTO 3
        FP1=(F1(I+1)-F1(I-1))/(X1(I+1)-X1(I-1))
3       IF(I.GE.N1) FP2=(F1(N)-F1(N-1))/(X1(N)-X1(N-1))
        IF(I.GE.N1) GOTO 4
        FP2=(F1(I+2)-F1(I))/(X1(I+2)-X1(I))
4       XPI1=XP-X1(I+1)
        XPI=XP-X1(I)
        L1=XPI1*LP1
        L2=XPI*LP2
        P=F1(I)*(1.-2.*LP1*XPI)*L1*L1+F1(I+1)*(1.-2.*LP2*XPI1)
     *  *L2*L2+FP2*XPI1*L2*L2+FP1*XPI*L1*L1
        RETURN
        END

* Numerical Recipes

      SUBROUTINE POLINT(XA,YA,N,X,Y,DY)
      PARAMETER (NMAX=10)
c      implicit real*8 (a-h, o-z) 
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX)

      NS=1
      DIF=ABS(X-XA(1))
      DO 11 I=1,N 
        DIFT=ABS(X-XA(I))
        IF (DIFT.LT.DIF) THEN
          NS=I
          DIF=DIFT
        ENDIF
        C(I)=YA(I)
        D(I)=YA(I)
11    CONTINUE
      Y=YA(NS)
      NS=NS-1
      DO 13 M=1,N-1
        DO 12 I=1,N-M
          HO=XA(I)-X
          HP=XA(I+M)-X
          W=C(I+1)-D(I)
          DEN=HO-HP
          IF(DEN.EQ.0.) then
	    den=1.d-4
	  end if
          DEN=W/DEN
          D(I)=HP*DEN
          C(I)=HO*DEN
12      CONTINUE
        IF (2*NS.LT.N-M)THEN
          DY=C(NS+1)
        ELSE
          DY=D(NS)
          NS=NS-1
        ENDIF
        Y=Y+DY
13    CONTINUE
      RETURN
      END
